<%@ page language="java"%>
<%@ page pageEncoding="UTF-8"%>
<%@ page import="com.ibm.rpm.WebUIConstants"%>
<%@ page import="com.ibm.rpm.framework.security.SecuredOperations"%>
<%@ page import="com.ibm.rpm.rest.RestConstants"%>
<%	
	request.setCharacterEncoding(WebUIConstants.UTF8); // Must absolutely be done before the first request.getParameter()
	// Fix ChangeRequest RATLC01034584
    // Code compatible Servlet 2.4 only
    // response.setCharacterEncoding(WebUIConstants.UTF8);
    // response.setContentType("text/javascript"); //$NON-NLS-1$
    // Code compatible Servlet 2.3 & 2.4
    response.setContentType("text/javascript; charset=UTF-8"); //$NON-NLS-1$
// End-of-fix ChangeRequest RATLC01034584
%>
/**
 * RPMSecurity is a singleton that encapsulates definitions for
 * security related constants and a factory function for
 * SecurityDescriptor objects
 */
 
com.ibm.rpm.util.RPMSecurity = { // singleton
	// This flag is used to disable security on the client
	// This flag will be removed after security is completely enabled and
	// tested for the 7.1 release.
	DISABLE_CLIENT_SECURITY: false,

	// Security container node
	SECID_CONTAINER: '<%= RestConstants.SECURITY_PARAM %>',
		
	// Base security flags
	SECID_CANVIEW: '<%= RestConstants.CAN_VIEW_OPERATION %>', 
	SECID_CANEDIT: '<%= RestConstants.CAN_EDIT_OPERATION %>',
	SECID_CANDELETE: '<%= RestConstants.CAN_DELETE_OPERATION %>',
	SECID_CANCONVERT: '<%= RestConstants.CAN_CONVERT_TO_OPERATION %>',
	SECID_CANCHANGETYPE: '<%= SecuredOperations.ChangeElementType %>',
	SECID_CANCHECKOUT: '<%= SecuredOperations.CheckOutOrCheckOutTo %>',
	
	// RTF flags
	SECID_CANVIEW_RTF: '<%= RestConstants.CAN_VIEW_OPERATION %>RTF', 
	SECID_CANEDIT_RTF: '<%= RestConstants.CAN_EDIT_OPERATION %>RTF',
	
	// Creation security flags
	SECID_CANCREATE_REQUIREMENT: '<%= SecuredOperations.CreateRequirements %>',
	SECID_CANCREATE_CHANGEREQUEST: '<%= SecuredOperations.CreateChangeRequests %>',
	SECID_CANCREATE_SERVICEREQUEST: '<%= SecuredOperations.CreateServiceRequests %>',
	SECID_CANCREATE_ACTION: '<%= SecuredOperations.CreateActions %>',
	SECID_CANCREATE_DEFECT: '<%= SecuredOperations.CreateDefects %>',
	SECID_CANCREATE_ISSUE: '<%= SecuredOperations.CreateIssues %>',
	SECID_CANCREATE_RISK: '<%= SecuredOperations.CreateRisks %>',
	SECID_CANCREATE_DOCUMENT: '<%= SecuredOperations.CreateDocuments %>',
 	SECID_CANCREATE_NOTESDOC: '<%= SecuredOperations.CreateNoteMinutes %>',
 	
	/**
	* Returns an instance of SecurityDescriptor for a given object
	*
	* @param obj an object that may contain security information
	* @return an instance of SecurityDescriptior
	*/
   	getSecurityDescriptor: function(object) {   		
		return new com.ibm.rpm.util.SecurityDescriptor(object);
   	},
   	
	/**
	* Returns the creation security flag for a given object type
	*
	* @param objType an object type
	* @return a creation security flag
	*/
   	getObjectCreationFlag: function(objectType) {
 		var creationFlags = {
	 		"Requirement": 		this.SECID_CANCREATE_REQUIREMENT,
	 		"ChangeRequest": 	this.SECID_CANCREATE_CHANGEREQUEST,
	 		"ServiceRequest": 	this.SECID_CANCREATE_SERVICEREQUEST,
	 		"Action": 			this.SECID_CANCREATE_ACTION,
	 		"Defect": 			this.SECID_CANCREATE_DEFECT,
	 		"Issue": 			this.SECID_CANCREATE_ISSUE,
	 		"Risk": 			this.SECID_CANCREATE_RISK,
	 		"Document": 		this.SECID_CANCREATE_DOCUMENT,
	 		"NoteMinutes": 		this.SECID_CANCREATE_NOTESDOC
 		};
		var item = creationFlags[objectType];
		dojo.lang.assert(item != null, "getObjectCreationFlag: " + 
			objectType + " not found in creationFlags map");
		return item;
   	}
   	
}
