<%@ page language="java"%>
<%@ page pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.MessageFormat"%>
<%@ page import="com.ibm.rpm.WebUIConstants"%>
<%@ page import="com.ibm.rpm.RPMSettingsBean"%>
<%@ page import="com.ibm.rpm.RPMUtilityBean"%>
<%@ page import="com.ibm.rpm.i18n.LabelExtractor"%>
<jsp:useBean id="utilityBean" scope="request" class="com.ibm.rpm.RPMUtilityBean"></jsp:useBean>
<%
    request.setCharacterEncoding(WebUIConstants.UTF8); // Must absolutely be done before the first request.getParameter()
	// Fix ChangeRequest RATLC01034584
	    // Code compatible Servlet 2.4 only
	    // response.setCharacterEncoding(WebUIConstants.UTF8);
	    // response.setContentType("text/html"); //$NON-NLS-1$
	    // Code compatible Servlet 2.3 & 2.4
	    response.setContentType("text/html; charset=UTF-8"); //$NON-NLS-1$
	// End-of-fix ChangeRequest RATLC01034584
    response.setHeader("Pragma", "No-cache"); //$NON-NLS-1$ //$NON-NLS-2$
    response.setHeader("Cache-Control", "no-cache"); //$NON-NLS-1$ //$NON-NLS-2$
    response.setDateHeader("Expires", 0); //$NON-NLS-1$
    
    utilityBean.setRequest(request);
    
    // Locale detection
    String languageId = request.getParameter("lang"); //$NON-NLS-1$
    if (languageId == null || languageId.length() == 0) {
        languageId = RPMUtilityBean.getLanguageId(request); 
    }
    // Verification that the locale is supported
    ResourceBundle languageList = ResourceBundle.getBundle("OlympiaLanguages", Locale.US); //$NON-NLS-1$
    try {
        languageList.getString(languageId);
    }
    catch (java.util.MissingResourceException ex0) {
        if (2 < languageId.length()) {
            languageId = languageId.substring(0, 2);
            try {
                languageList.getString(languageId);
            }
            catch (java.util.MissingResourceException ex1) {
                languageId = "en"; // Default language //$NON-NLS-1$
            }
        }
        else {
            languageId = "en"; // Default language //$NON-NLS-1$
        }
    }
    // Saving of the accepted locale for the rest of the application
    session.setAttribute(RPMUtilityBean.LANGUAGE_ID, languageId);
    Locale locale = RPMUtilityBean.getLocale(request);
    
    // Process the server name
    String serverName = RPMSettingsBean.getInstance().getServerDisplayName(locale);
  
    boolean isDebugMode = RPMUtilityBean.hasDebugConsole();
%>

<html>
<head>
	<title><%=
	    LabelExtractor.get("dojo_common_applicationName", locale) //$NON-NLS-1$
    %></title>
	<link href="<%= request.getContextPath() %>/theme/style.css" rel="stylesheet" type="text/css" />
	<link href="<%= request.getContextPath() %>/theme/login.css" rel="stylesheet" type="text/css" />	
	<link rel="shortcut icon" href="<%= request.getContextPath() %>/icons/favicon.ico" type="image/x-icon"/>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<meta http-equiv="Window-target" content="_top"> 

	<script type="text/javascript">
		var djConfig = {
			isDebug: <%= isDebugMode ? Boolean.TRUE.toString() : Boolean.FALSE.toString() %>,
            debugAtAllCosts: <%= isDebugMode ? Boolean.TRUE.toString() : Boolean.FALSE.toString() %>,
            locale: "<%= languageId %>"
		};
	</script>
	<script type="text/javascript" src="<%= request.getContextPath() %>/dojo/dojo.js"></script>
	<script language="JavaScript" type="text/javascript">		
		//require statements
		dojo.require("dojo.widget.LayoutContainer");
		dojo.require("dojo.widget.ContentPane");
		
		dojo.setModulePrefix("com.ibm", "../dojo-rpm/com/ibm");		
		
		dojo.require("com.ibm.rpm.util.LocalizationEngine");
  
        //all dojo.require above this line
        dojo.hostenv.writeIncludes(); //makes debugging in Venkman possible
    </script>
    <script language="JavaScript" type="text/javascript">   
		// initialize LocalizatoinEngine with the selected locale
		com.ibm.rpm.util.LocalizationEngine.getInstance("<%= languageId %>");
		
		dojo.require("com.ibm.rpm.widget.RPMButton");
    </script>
    <script language="JavaScript" type="text/javascript">   
		dojo.addOnLoad(function(){
			// dojo layout needs to be resized (bug in dojo)
			dojo.widget.byId("paneMainLogin").onResized();
			dojo.byId("usernameField").select();	
			
			var fragment = window.location.hash;
			if (fragment == null || fragment == "" || fragment == "#") {
				fragment = "";
			} else if (fragment.charAt(0) == "#"){
				fragment = fragment.substr(1);
			}
			var fragmentInputNode = dojo.byId("<%= WebUIConstants.ORIGINAL_URL_FRAGMENT_ATT %>");
			if (fragmentInputNode != null) {
				fragmentInputNode.value = fragment;
			}
			
			if (dojo.widget.byId("com.ibm.rpm.app:RPMNavigator")) { 
				// session expired, we need to reload starting from the top
				// we might need to refactor this hack if it produces visual bugs
				window.location.href = "<%= request.getContextPath() %>";
			}
			
			// set focus on username field
			if (document.FormLogin != null) {
				document.FormLogin.j_username.focus();
			}
			else if (document.getElementById("oldPasswordField") != null) {
				document.getElementById("oldPasswordField").focus();
			}
		}); 
	</script>
    <script language="JavaScript" type="text/javascript">
    	dojo.addOnLoad(function(){
            var languageList = document.getElementById("languageList");
            if (languageList != null) {
                // Select the specified language into the select box listing all available languages
                languageList.value = "<%= languageId %>";
            }
        });
    </script>
    <script type="text/javascript">
        // In the rest of the application, behavior are attached to the call of
        // RPMButton.onClick() [AOP mechanism, used with dojo.event.kwConnect()]
        // In the login page, the default RPMButton.onClick() is replaced by an
        // action on the contained <input /> field which has the type "submit".
        dojo.addOnLoad(function(){
            var btn0 = dojo.widget.byId("loginBtn");
            if (btn0 != null) {
                btn0.onClick = function() {
                    btn0.inputNode.click();
                }
            }
            var btn1 = dojo.widget.byId("rpmButtonChangePassWidget");
            if (btn1 != null) {
                btn1.onClick = function() {
                    btn1.inputNode.click();
                }
            }
            var btn2 = dojo.widget.byId("rpmButtonCancelWidget");
            if (btn2 != null) {
                btn2.onClick = function() {
                    btn2.inputNode.click();
                }
            }
        });
    </script>
</head>
<body style="overflow: hidden;">
<% if (isDebugMode) { %>
    <div id="widgetDebug" dojoType="DebugConsole"
      title="Debug Console"
      iconSrc="../icons/debug.png"
      style="width:180px;height:250px;left:10px;top:400px;z-index:2000;"
      hasShadow="false"
      resizable="true"
      displayMinimizeAction="true"
    ></div>
<% } %>

<%
String displayMode = (String) request.getAttribute(WebUIConstants.LOGIN_MODE_WORD);
if (WebUIConstants.LOGIN_MODE_CHANGE_PASSWORD.equals(displayMode)) {
%>
<form name="ChangePasswordForm" action="<%= request.getContextPath() %>/ChangePassword?lang=<%= languageId %>" method="post">
<%
}
else if (WebUIConstants.LOGIN_MODE_LEGACY.equals(displayMode)) {
%>
<form name="FormLogin" action="<%= request.getContextPath() %>/SecurityCheck?lang=<%= languageId %>" method="post">
<%
}
else { // Container managed security
%>
<form name="FormLogin" action="j_security_check?lang=<%= languageId %>" method="post">
<%
}
%>
<input type="hidden" 
	name="<%= WebUIConstants.ORIGINAL_URL_FRAGMENT_ATT %>"
	id="<%= WebUIConstants.ORIGINAL_URL_FRAGMENT_ATT %>"
	value=""
	/>
<div id="paneMainLogin" dojoType="LayoutContainer" layoutChildPriority="top-bottom" style="width: 100%; height: 100%;">
	<div dojoType="ContentPane" layoutAlign="top">
		<table width="100%" border="0" cellpadding="0" cellspacing="0" class="rpm_header">
			<tr>
				<td width="20" class="rpm_header_left">
					<img src="<%= request.getContextPath() %>/theme/spacer.png" width="20" height="39" alt="" />
				</td>
				<td align="left" valign="middle" nowrap="nowrap" class="rpm_header rpm_name">
					<img id="rpmImgNodeId"
						src="<%= request.getContextPath() %>/theme/rational.png" 
						alt="<%=
						    LabelExtractor.get("dojo_common_applicationName", locale) //$NON-NLS-1$
                        %>"
						title="<%=
						    LabelExtractor.get("dojo_common_applicationName", locale) //$NON-NLS-1$
                        %>"
						align="absmiddle"
						width="181"
						height="22"
					/>
				</td>
				<td width="13" class="rpm_header_separator">
					<img src="<%= request.getContextPath() %>/theme/spacer.png" width="13" height="39" alt="" />
				</td>
				<td width="90%" align="right">
					<table border="0" cellpadding="0" cellspacing="0" class="rpm_userinfo" width="100%" style="margin: 0px;">
						<tr>
							<td>
                                  <%=
                                      MessageFormat.format(
                                              LabelExtractor.get("dojo_login_version", locale), //$NON-NLS-1$
                                              new Object[] {
                                                      utilityBean.getVersion().replace('$', ' '),
                                                      utilityBean.getBuild().replace('$', ' ')
                                              }
                                      )
                                  %>
                                </td>
                                <td>
                                <%=
                                    MessageFormat.format(
                                            LabelExtractor.get("dojo_header_serverName", locale), //$NON-NLS-1$
                                            new Object[] {
                                                serverName
                                            }
                                    )
                                %>
							</td>
							<td align="right">
								<a
									target="HelpPages"
									href="<%= request.getContextPath() %>/RPM_WebUI_Help/help.htm"
									onclick="window.open(this.href, 'HelpPages'); return false;"
								><%=
								    LabelExtractor.get("dojo_common_help", locale) //$NON-NLS-1$
                                %></a>
								|
								<a
									target="AboutBox"
									href="<%= request.getContextPath() %>/olympiaAbout.jsp"
									onclick="window.open(this.href, 'AboutBox', 'width=650,height=475,resizable=1,directories=0,status=0,titlebar=0,toolbar=0'); return false;"
								><%=
								    LabelExtractor.get("dojo_common_about", locale) //$NON-NLS-1$
                                %></a>
							</td>
						</tr>
					</table>
				</td>
				<td width="20" align="right" class="rpm_header_right">
					<span class="rpm_header_left">
						<img src="<%= request.getContextPath() %>/theme/spacer.png" width="20" height="39" alt="" />
					</span>
				</td>
			</tr>
		</table>
		<table width="100%" border="0" cellpadding="0" cellspacing="0">
			<tr><td style="height:1px;background-color:#999999"></td></tr>
			<tr><td style="height:1px;background-color:#D0D0D0"></td></tr>
			<tr><td style="height:1px;background-color:#E0E0E0"></td></tr>
		</table>
	</div>
	<div dojoType="ContentPane" layoutAlign="client">
		<table width="100%" height="100%" border="0">
			<tr>
				<td align="center" valign="middle">
				<br />
					<table width="400" border="0" cellpadding="0" cellspacing="0" class="rpm_login">
						<tr>
							<th width="6" class="rpm_titlebar_left">
								<img src="<%= request.getContextPath() %>/theme/spacer.png" width="4" height="25" alt="" />
							</th>
							<%
							if (WebUIConstants.LOGIN_MODE_CHANGE_PASSWORD.equals(displayMode)) {
							%>
							<th nowrap="nowrap">
                                <%=
                                    LabelExtractor.get("dojo_login_changePsw_title", locale) //$NON-NLS-1$
                                %>
                            </th>
							<%
							}
							else { // login screen
							%>
							<th nowrap="nowrap">
                                <%=
                                    LabelExtractor.get("dojo_login_login_title", locale) //$NON-NLS-1$
                                %>
                            </th>
							<%
							}
							%>
							<th width="4" class="rpm_titlebar_right">
								<img src="<%= request.getContextPath() %>/theme/spacer.png" width="4" height="25" alt="" />
							</th>
						</tr>
						<tr>
							<td colspan="3" align="center" valign="middle" class="rpm_content">
								<% if (request.getHeader(WebUIConstants.MESSAGE_ATT) != null
									   || session.getAttribute(WebUIConstants.MESSAGE_ATT) != null) { %>
								<div align="left" class="rpm_error" id="div_login_errors">
									<% if (request.getHeader(WebUIConstants.MESSAGE_ATT) != null) { %>
									<img src="<%= request.getContextPath() %>/icons/error.png" width="16" height="16" align="top" alt="Error" />										
									<%= request.getHeader(WebUIConstants.MESSAGE_ATT) %>
									<% } %>
									<% if (session.getAttribute(WebUIConstants.MESSAGE_ATT) != null) { %>
									<img src="<%= request.getContextPath() %>/icons/alert.png" width="16" height="16" align="top" alt="Warning" />										
									<%= session.getAttribute(WebUIConstants.MESSAGE_ATT) %>
									<% } %>
								</div>
								<% } %>  
								<table border="0" cellpadding="2" cellspacing="5" style="margin-top:8px;">
									<%
									if (WebUIConstants.LOGIN_MODE_CHANGE_PASSWORD.equals(displayMode)) {
									%>
									<tr>
										<td class="rpm_label">
                                            <label for="usernameField">
                                                <%=
                                                    LabelExtractor.get("dojo_login_usernameField", locale) //$NON-NLS-1$
                                                %>
                                            </label>
                                        </td>
										<td>
											<!-- Differs from the login case just with the field name -->
											<input id="usernameField" name="<%= WebUIConstants.USERNAME_ATT %>" type="text" class="rpm_login" maxlength="50"/ value="<%=utilityBean.getUsername()%>" readonly>
										</td>
									</tr>
									<tr>
                                        <td class="rpm_label">
                                            <label for="oldPasswordField">
                                                <%=
                                                    LabelExtractor.get("dojo_login_oldPasswordField", locale) //$NON-NLS-1$
                                                %>
                                            </label>
                                        </td>
										<td>
											<input id="oldPasswordField" name="<%= WebUIConstants.OLD_PASSWORD_ATT%>" type="password" class="rpm_login" maxlength="50"/>
										</td>
									</tr>
									<tr>
                                        <td class="rpm_label">
                                            <label for="newPasswordField">
                                                <%=
                                                    LabelExtractor.get("dojo_login_newPasswordField", locale) //$NON-NLS-1$
                                                %>
                                            </label>
                                        </td>
										<td>
											<input id="newPasswordField" name="<%= WebUIConstants.NEW_PASSWORD_ATT%>" type="password" class="rpm_login" maxlength="50"/>
										</td>
									</tr>
									<tr>
                                        <td class="rpm_label">
                                            <label for="confirmPasswordField">
                                                <%=
                                                    LabelExtractor.get("dojo_login_confirmPasswordField", locale) //$NON-NLS-1$
                                                %>
                                            </label>
                                        </td>
										<td>
											<input id="confirmPasswordField" name="<%= WebUIConstants.CONFIRMATION_ATT%>" type="password" class="rpm_login" maxlength="50"/>
										</td>
									</tr>
									<tr>
										<td align="right">
											<div
												id="rpmButtonChangePassWidget"
												dojoType="RPMButton"
												submit="true"
												caption="<%=
												    LabelExtractor.get("dojo_login_changePswButton", locale) //$NON-NLS-1$
                                                %>"
												name="<%= WebUIConstants.ACTION_TYPE_CHANGE_PASSWORD%>" 
											></div>
										</td>
										<td align="left">
											<div
												id="rpmButtonCancelWidget"
												dojoType="RPMButton"
												submit="true"
												caption="<%=
												    LabelExtractor.get("dojo_common_cancel", locale) //$NON-NLS-1$
                                                %>"
												name="<%= WebUIConstants.ACTION_TYPE_CANCEL%>" 
											></div>
										</td>
									</tr>
									<%
									}
									else { // Login case
									%>
									<tr>
                                        <td class="rpm_label">
                                            <label for="usernameField">
                                                <%=
                                                    LabelExtractor.get("dojo_login_usernameField", locale) //$NON-NLS-1$
                                                %>
                                            </label>
                                        </td>
										<td>
											<!-- Differs from the change password case just with the field name -->
											<input id="usernameField" name="<%= WebUIConstants.J_USERNAME_ATT %>" type="text" class="rpm_login" maxlength="50" value="<%=utilityBean.getUsername()%>"/>
										</td>
									</tr>
									<tr>
                                        <td class="rpm_label">
                                            <label for="passwordField">
                                                <%=
                                                    LabelExtractor.get("dojo_login_passwordField", locale) //$NON-NLS-1$
                                                %>
                                            </label>
                                        </td>
										<td>
											<input id="passwordField" name="<%= WebUIConstants.J_PASSWORD_ATT %>" type="password" class="rpm_login" maxlength="50"/>
										</td>
									</tr>
                                    <tr>
                                          <td class="rpm_label">
                                              <label for="languageList">
                                                  <%=
                                                      LabelExtractor.get("dojo_login_languageSelector", locale) //$NON-NLS-1$
                                                  %>
                                              </label>
                                          </td>
                                          <td>
                                              <%
                                              Enumeration keys = languageList.getKeys();
                                              // TODO: replace the <select /> by an disabled <input /> if there's just one language available
                                              %>
                                              <select id="languageList" name="languageList" onchange="dojo.widget.byId('loginBtn').enable(false);window.location='?lang='+this.value;">
                                                  <%
                                                  while (keys.hasMoreElements()) {
                                                     String key = (String) keys.nextElement();
                                                     String value = languageList.getString(key);
                                                  %>
                                                  <option value="<%= key %>"><%= value %></option>
                                                  <%
                                                  }
                                                  %>
                                              </select>
                                          </td>
                                    </tr>
									<tr>
										<td>&nbsp;</td>
										<td>
											<div
												id="loginBtn"
												submit="true"
												dojoType="RPMButton"
                                                caption="<%=
                                                    LabelExtractor.get("dojo_login_login_button", locale) //$NON-NLS-1$
                                                %>"
												name="<%= WebUIConstants.ACTION_TYPE_LOGIN %>" 
											></div>
										</td>
									</tr>
									<%
									}
									%>
								</table>
								<br />
							</td>
						</tr>
						<tr>
							<td width="4" height="4" class="rpm_lastrow_left"><img
									src="<%= request.getContextPath() %>/theme/appcorner_bottom_left.png"
									width="4"
									height="4"
									alt=""
								/></td>
							<td width="99%" height="4" class="rpm_lastrow"></td>
							<td width="4" height="4" class="rpm_lastrow_right"><img
									src="<%= request.getContextPath() %>/theme/appcorner_bottom_right.png"
									width="4"
									height="4"
									alt=""
								/></td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
	</div>
	<div dojoType="ContentPane" layoutAlign="bottom">
		<table width="100%" class>
			<tr>
				<td width="60">
					<img src="<%= request.getContextPath() %>/theme/spacer.png" width="42" height="16" alt="" />
				</td>
				<td align="center" style="color: grey; font-size: 8pt;">
                    <%=
                        MessageFormat.format(
                                LabelExtractor.get("dojo_login_copyrightNotice", locale), //$NON-NLS-1$
                                new Object[] {
                                    String.valueOf((new GregorianCalendar()).get(Calendar.YEAR))
                                }
                        )
                    %>
				</td>
				<td width="60">
					<img
                        id="ibmLogo"
                        src="<%= request.getContextPath() %>/theme/IBM-logo.png"
                        alt="<%=
                            LabelExtractor.get("dojo_login_ibmLogoAlt", locale) //$NON-NLS-1$
                        %>" />
				</td>
			</tr>
		</table>
	</div>
</div>
</form>

<!-- End of Content Here -->
<%
session.setAttribute(WebUIConstants.MESSAGE_ATT,null);
%>
</body>
</html>