<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<%@ page language="java"%>
<%@ page pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.MessageFormat"%>
<%@ page import="com.ibm.rpm.WebUIConstants"%>
<%@ page import="com.ibm.rpm.RPMUtilityBean"%>
<%@ page import="com.ibm.rpm.i18n.LabelExtractor"%>
<%@ page import="com.ibm.rpm.rest.RestConstants"%>
<%@ page import="com.ibm.rpm.rest.operation.LoadAboutOperation"%>
<%@ page import="com.ibm.rpm.rest.operation.LoadSettingsOperation"%>
<%@ page import="com.ibm.rpm.rest.generators.AbstractRPMGenerator"%>
<%@ page import="java.io.FileInputStream"%>
<%@ page import="java.io.IOException"%>
<%
    request.setCharacterEncoding(WebUIConstants.UTF8); // Must absolutely be done before the first request.getParameter()
	// Fix ChangeRequest RATLC01034584
	    // Code compatible Servlet 2.4 only
	    // response.setCharacterEncoding(WebUIConstants.UTF8);
	    // response.setContentType("text/html"); //$NON-NLS-1$
	    // Code compatible Servlet 2.3 & 2.4
	    response.setContentType("text/html; charset=UTF-8"); //$NON-NLS-1$
	// End-of-fix ChangeRequest RATLC01034584
    
    String languageId = RPMUtilityBean.getLanguageId(request);
    Locale locale = RPMUtilityBean.getLocale(request);
    
    String unkownInfo = LabelExtractor.get("dojo_aboutBox_unknownInfo", locale); //$NON-NLS-1$
    String retreivingInfo = LabelExtractor.get("dojo_aboutBox_retreivingInfo", locale); //$NON-NLS-1$
  
    boolean isDebugMode = RPMUtilityBean.hasDebugConsole();
%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title><%=
        LabelExtractor.get("dojo_common_applicationName", locale) //$NON-NLS-1$
    %></title>
	<link rel="shortcut icon" href="icons/favicon.ico" type="image/x-icon"/>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	<link href="theme/style.css" type="text/css" rel="stylesheet"/>	
	<style type="text/css" rel="stylesheet">
	html, body{	
	  width: 100%;
	  height: 100%;
	  padding: 0px;
	  margin: 0px;
	  overflow: hidden;
	}
	</style>
	<script type="text/javascript" language="JavaScript">
		djConfig = {
			isDebug: <%= isDebugMode ? Boolean.TRUE.toString() : Boolean.FALSE.toString() %>,
            debugAtAllCosts: <%= isDebugMode ? Boolean.TRUE.toString() : Boolean.FALSE.toString() %>,
            locale: "<%= languageId %>"
		};
	</script>
	<script type="text/javascript" language="JavaScript" src="dojo/dojo.js"></script>
	<script type="text/javascript" language="JavaScript">
		// standard components
		dojo.require("dojo.debug.Firebug");
		dojo.require("dojo.widget.HtmlWidget");
		dojo.require("dojo.widget.DebugConsole");
		dojo.require("dojo.widget.LayoutContainer");
		dojo.require("dojo.widget.ContentPane");
		dojo.require("dojo.event.*");
		dojo.require("dojo.html.*");

		dojo.setModulePrefix("com.ibm", "../dojo-rpm/com/ibm");
		dojo.require("com.ibm.rpm.util.LocalizationEngine");
    
        //all dojo.require above this line
        dojo.hostenv.writeIncludes(); //makes debugging in Venkman possible
    </script>
	<script src="RPMSecurity.jsp"></script>
    <script language="JavaScript" type="text/javascript">   
		// initialize LocalizatoinEngine with the selected locale
		com.ibm.rpm.util.LocalizationEngine.getInstance("<%= languageId %>");
		
		// olympia components
		dojo.require("com.ibm.rpm.widget.RPMHeader");		
		dojo.require("com.ibm.rpm.widget.RPMButton");
		dojo.require("com.ibm.rpm.intf.*");
	</script>
	<script type="text/javascript" language="JavaScript">
    	var page = new Object();
    	page.loadRestBuildInfo = function() {
    		dojo.io.bind({
    			url: "<%= request.getContextPath() %>/Do?operation=loadAbout",
    			load: page.processRestBuildInfo,
    			mimeType: "text/javascript"
    		});
    	}
    	page._dataLoaded = false;
    	page.isDataLoaded = function() {
    		return page._dataLoaded;
    	}
    	page.processRestBuildInfo = function (type, data, evt) {
    		var info = {};
    		try {
    			eval("info="+data);
    		}
    		catch(ex) {
    			alert(ex);
    		}
    		
            var webServicesTag = "<%= LoadAboutOperation.WS_VERSION %>";
            var currentDbTag = "<%= LoadAboutOperation.DB_VERSION %>";
            var recommendedDbTag = "<%= RestConstants.SERVER_BUILD_NUM_OBJECT %>";
            var versionTag = "<%= LoadSettingsOperation.VERSION %>";
            var buildTag = "<%= LoadSettingsOperation.BUILD %>";
            var valueTag = "<%= AbstractRPMGenerator.TAG_VALUE %>";
            var unkownLabel = "<%= unkownInfo %>";
            
    		// WebServices build info
    		if (info[webServicesTag] != null) {
    			if (info[webServicesTag][buildTag] == null) {
    				info[webServicesTag][buildTag] = {};
    				info[webServicesTag][buildTag][valueTag] = unkownLabel;
    			}
                else if (info[webServicesTag][buildTag][valueTag] == "null") {
                    info[webServicesTag][buildTag][valueTag] = unkownLabel;
                }
    			if (info[webServicesTag][versionTag] == null) {
    				info[webServicesTag][versionTag] = {};
    				info[webServicesTag][versionTag][valueTag] = unkownLabel;
    			}
                else if (info[webServicesTag][versionTag][valueTag] == "null") {
                    info[webServicesTag][versionTag][valueTag] = unkownLabel;
                }
    		}
    		else {
    			info[webServicesTag] = {};
    			info[webServicesTag][buildTag] = {};
    			info[webServicesTag][buildTag][valueTag] = unkownLabel;
    			info[webServicesTag][versionTag] = {};
    			info[webServicesTag][versionTag][valueTag] = unkownLabel;
    		}
    		dojo.byId("wsBuild").innerHTML = page._getBuildNumber(info[webServicesTag][buildTag][valueTag]);
    		dojo.byId("wsVersion").innerHTML = info[webServicesTag][versionTag][valueTag];
    		
    		// Database build info
    		if (info[currentDbTag] != null) {
    			if (info[currentDbTag][buildTag] == null) {
    				info[currentDbTag][buildTag] = {};
    				info[currentDbTag][buildTag][valueTag] = unkownLabel;
    			}
                else if (info[currentDbTag][buildTag][valueTag] == "null") {
                    info[currentDbTag][buildTag][valueTag] = unkownLabel;
                }
    		}
    		else {
    			info[currentDbTag] = {};
    			info[currentDbTag][buildTag] = {};
    			info[currentDbTag][buildTag][valueTag] = unkownLabel;
    		}
    		dojo.byId("dbBuild").innerHTML = page._getBuildNumber(info[currentDbTag][buildTag][valueTag]);
    		
    		// Database current build info
    		if (info[recommendedDbTag] != null) {
    			if (info[recommendedDbTag][versionTag] == null) {
    				info[recommendedDbTag][versionTag] = {};
    				info[recommendedDbTag][versionTag][valueTag] = unkownLabel;
    			}
                else if (info[recommendedDbTag][buildTag][valueTag] == "null") {
                    info[recommendedDbTag][buildTag][valueTag] = unkownLabel;
                }
    		}
    		else {
    			info[recommendedDbTag] = {};
    			info[recommendedDbTag][versionTag] = {};
    			info[recommendedDbTag][versionTag][valueTag] = unkownLabel;
    		}
    		dojo.byId("dbCurrentBuild").innerHTML =  page._getBuildNumber(info[recommendedDbTag][buildTag][valueTag]);
    		
    		page._dataLoaded = true;
    	}
    	page._getBuildNumber = function(source) {
    		if (source.charAt(0) == '$') {
    			return source;
    		}
    		var output = source.split('.');
    		if (output.length == 1) {
    			return source;
    		}
    		return output[output.length - 1];
    	}
    	dojo.addOnLoad(page.loadRestBuildInfo);
  	</script>
</head>
<body>
<% if (isDebugMode) { %>
    <div id="widgetDebug" dojoType="DebugConsole"
      title="Debug Console"
      iconSrc="../icons/debug.png"
      style="width:180px;height:250px;left:10px;top:400px;z-index:2000;"
      hasShadow="false"
      resizable="true"
      displayMinimizeAction="true"
    ></div>
<% } %>

	<div dojoType="LayoutContainer" layoutChildPriority="top-bottom"  style="width:100%;height:100%;">
		<div id="paneMainHeader" dojoType="ContentPane" style="overflow:hidden;"
			layoutAlign="top">
				<div dojoType="RPMHeader" 
					showLoginInfo="false"
					showLogout="false"
					showIntro="false"
					></div>
		</div>
		<div dojoType="ContentPane" layoutAlign="client" style="padding: 6px;">
			<%
			String webuiVersion = unkownInfo;
			String webuiBuild = unkownInfo;
			String wsVersion = retreivingInfo;
			String wsBuild = retreivingInfo;
			String dbBuild = retreivingInfo;
			String dbCurrentBuild = retreivingInfo;
			Properties properties = new Properties();
		    try {
				ServletContext servletContext = session.getServletContext();
				properties.load(new FileInputStream(servletContext.getRealPath("")+ "/dependencies.properties")); //$NON-NLS-1$ //$NON-NLS-2$
				webuiVersion = properties.getProperty("dependency.rpm.rpm-web-ui.version"); //$NON-NLS-1$
				webuiBuild = properties.getProperty("dependency.rpm.rpm-web-ui.build"); //$NON-NLS-1$
				String[] webuiBuildParts = webuiBuild.split("\\."); //$NON-NLS-1$
				if (1 < webuiBuildParts.length) {
					webuiBuild = webuiBuildParts[webuiBuildParts.length - 1];
				}
		    }
		    catch (IOException e) {
		    	// Nothing
		    }
		    %>
		    <table style="margin: 0; padding: 0;">
		        <tr>
		            <td style="vertical-align: top; padding-top: 12px; padding-right:20px;">
		            	<img
		            		id="rpmLogoImg"
		            		width="130px"
		            		height="165px"
		            		alt=""
		            		title="<%=
		            		    LabelExtractor.get("dojo_aboutBox_IBMRationalSoftwareImageAlt", locale) //$NON-NLS-1$
                            %>"
		            		src="theme/about-rational-logo.png"
	            		/>
		            </td>
		            <td>
		            	<p style="font-weight: bold;">
		            		<%= 
		            		    LabelExtractor.get("dojo_common_applicationName", locale) //$NON-NLS-1$
                            %>
		            	</p>
		            	<table style="margin: 0; padding: 0">
		            		<tr>
		            			<td style="padding-right: 5px;" id="uiVerLabel">
                                  <%= 
                                      LabelExtractor.get("dojo_aboutBox_webuiVersionLabel", locale) //$NON-NLS-1$
                                  %>
                                </td>
                                <td id="webuiVersion" style="padding-right: 10px; text-align: right;"><%=webuiVersion %></td>
		            			<td style="padding-right: 5px;" id="uiBuildLabel">
                                  <%= 
                                      LabelExtractor.get("dojo_aboutBox_webuiBuildLabel", locale) //$NON-NLS-1$
                                  %>
                                </td>
                                <td id="webuiBuild" style="padding-right: 10px; text-align: right;"><%=webuiBuild %></td>
	            			</tr>
		            		<tr>
		            			<td style="padding-right: 5px;" id="wsVerLabel">
                                  <%= 
                                      LabelExtractor.get("dojo_aboutBox_webservicesVersionLabel", locale) //$NON-NLS-1$
                                  %>
                                </td>
                                <td id="wsVersion" style="padding-right: 10px; text-align: right;"><%=wsVersion %></td>
		            			<td style="padding-right: 5px;" id="wsBuildLabel">
                                  <%= 
                                      LabelExtractor.get("dojo_aboutBox_webservicesBuildLabel", locale) //$NON-NLS-1$
                                  %>
                                </td>
                                <td id="wsBuild" style="padding-right: 10px; text-align: right;"><%=wsBuild %></td>
	            			</tr>
		            		<tr>
		            			<td style="padding-right: 5px;" id="dbRecBuildLabel">
                                  <%=
                                      LabelExtractor.get("dojo_aboutBox_dbRecommendedBuildLabel", locale) //$NON-NLS-1$
                                  %>
                                </td>
                                <td id="dbBuild" style="padding-right: 10px; text-align: right;"><%=dbBuild %></td>
	            			</tr>
		            		<tr>
		            			<td style="padding-right: 5px;" id="dbCurBuildLabel">
                                  <%=
                                      LabelExtractor.get("dojo_aboutBox_dbCurrentBuildLabel", locale) //$NON-NLS-1$
                                  %>
                                </td>
                                <td id="dbCurrentBuild" style="padding-right: 10px; text-align: right;"><%=dbCurrentBuild %></td>
	            			</tr>
		            	</table>
		            	<p>
		            		<%=
                                MessageFormat.format(
                                        LabelExtractor.get("dojo_login_copyrightNotice", locale), //$NON-NLS-1$
                                        new Object[] {
                                                String.valueOf((new GregorianCalendar()).get(Calendar.YEAR))
                                        }
                                )
                            %>
		            	</p>
		            	<p>
                            <%= 
                                LabelExtractor.get("dojo_aboutBox_noticeAreaLabel", locale) //$NON-NLS-1$
                            %><br/>
                            <div style="height: 120px; width: 280px; background-color: white; border: 1px solid black; padding: 5px;">
                                <%=
                                MessageFormat.format(
                                        LabelExtractor.get("dojo_aboutBox_noticeAreaContent", locale), //$NON-NLS-1$
                                        new Object[] {
                                            // First parameter is the opening link tag
                                            "<a href=\"" + request.getContextPath() + //$NON-NLS-1$
                                            "/RPM_WebUI_License/" + RPMUtilityBean.getLanguageId(request) + //$NON-NLS-1$
                                            ".html\" target=\"webuiLicenses\">", //$NON-NLS-1$
                                            // Second parameter is the closing link tag
                                            "</a>" //$NON-NLS-1$
                                        }
                                )
                                %>
                            </div>
		            	</p>
		            </td>
	            </tr>
		    </table>
		    <table>
		        <tr>
		            <td>
		            	<!-- Source: http://hurwww.hursley.ibm.com/java/legal/logo14_se.html -->
		            	<!-- Original size: 181x315, Desired size: 20%x20% -->
		            	<img
		            		src="theme/about-java-compatible.gif"
		            		width="36px"
		            		height="63px"
		            		alt=""
		            		title="<%= 
		            		    LabelExtractor.get("dojo_aboutBox_javaImageAlt", locale) //$NON-NLS-1$
                            %>"
	            		/>
		            </td>
		            <td>
		            	<%= 
		            	    LabelExtractor.get("dojo_aboutBox_legalText", locale) //$NON-NLS-1$
                        %>
		            </td>
		            <td style="vertical-align: bottom;">
						<div
							id="closeBtn"
							dojoType="RPMButton"
							onclick="window.close();"
							style="margin-right: 5px;"
                            caption="<%= 
                                LabelExtractor.get("dojo_common_close", locale) //$NON-NLS-1$
                            %>"
						>
						</div>
					</td>
	            </tr>
		    </table>
		</div>
	</div>
</body>
</html>